#include "board.h"
#include "flash.h"

__ramfunc int AT91F_Flash_Write(unsigned int Flash_Address, int size, unsigned int * buff)
{
    // adres bazowy rejestrow zwiazanych z obsluga FLASH
    AT91PS_MC ptMC = AT91C_BASE_MC;
    unsigned int i, page, status;
    unsigned int * Flash;
    status = 0;

    Flash = (unsigned int *) Flash_Address;
    page = ((Flash_Address - (unsigned int)AT91C_IFLASH )/AT91C_IFLASH_PAGE_SIZE);

    // kopiowanie wartosci w miejsce gdzie pamieci zostana zapisane dane
    for (i=0; (i < AT91C_IFLASH_PAGE_SIZE) & (size > 0) ;i++, Flash++,buff++,size-=4 )
    {
        // (each assignments copies 4B)
        *Flash=*buff;
    }

    //disable interrupts
    //unsigned long ulIntrStat = AT91C_BASE_AIC->AIC_IMR;
    //AT91C_BASE_AIC->AIC_IDCR = 0xFFFFFFFF;

    // write
    ptMC->MC_FCR =AT91C_MC_CORRECT_KEY | AT91C_MC_FCMD_START_PROG | (AT91C_MC_PAGEN & (page<<8));

    // wait for end of operation
    while ((status & AT91C_MC_FRDY) != AT91C_MC_FRDY )
    {
        status = AT91C_BASE_MC->MC_FSR;
    }

    //restore interrupts
    //AT91C_BASE_AIC->AIC_IECR = ulIntrStat;

    if ( (status & ( AT91C_MC_PROGE | AT91C_MC_LOCKE ))!=0)
        return 1;
    return 0;
}

//*----------------------------------------------------------------------------
//* \fn    AT91F_Flash_Read
//* \brief Odczyt danych z Flash'a
//*----------------------------------------------------------------------------
void AT91F_Flash_Read(unsigned int add, unsigned int size, unsigned int * read_buff)
{
    unsigned int * start_add = (unsigned int *) add;

    for (int i=0 ; i < size ; i++)
    {
        *(read_buff + i) = *(start_add + i);
    }
}

